/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ProjectPublicationRequestDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { PublicationRequestForCreationDto } from '../../@coscine/model';
/**
 * ProjectPublicationRequestApi - axios parameter creator
 * @export
 */
export const ProjectPublicationRequestApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdPublicationsRequestsOptions: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdPublicationsRequestsOptions', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/publications/requests`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Creates a new publication request.
         * @param {string} projectId The Id or slug of the project.
         * @param {PublicationRequestForCreationDto} [publicationRequestForCreationDto] The publication request data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createPublicationRequest: async (projectId: string, publicationRequestForCreationDto?: PublicationRequestForCreationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createPublicationRequest', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/publications/requests`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(publicationRequestForCreationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a publication request.
         * @param {string} projectId The ID of the project.
         * @param {string} publicationRequestId The ID of the publication request.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPublicationRequest: async (projectId: string, publicationRequestId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getPublicationRequest', 'projectId', projectId)
            // verify required parameter 'publicationRequestId' is not null or undefined
            assertParamExists('getPublicationRequest', 'publicationRequestId', publicationRequestId)
            const localVarPath = `/api/v2/projects/{projectId}/publications/requests/{publicationRequestId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"publicationRequestId"}}`, encodeURIComponent(String(publicationRequestId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectPublicationRequestApi - functional programming interface
 * @export
 */
export const ProjectPublicationRequestApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectPublicationRequestApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdPublicationsRequestsOptions(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdPublicationsRequestsOptions(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectPublicationRequestApi.apiV2ProjectsProjectIdPublicationsRequestsOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Creates a new publication request.
         * @param {string} projectId The Id or slug of the project.
         * @param {PublicationRequestForCreationDto} [publicationRequestForCreationDto] The publication request data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createPublicationRequest(projectId: string, publicationRequestForCreationDto?: PublicationRequestForCreationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectPublicationRequestDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createPublicationRequest(projectId, publicationRequestForCreationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectPublicationRequestApi.createPublicationRequest']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a publication request.
         * @param {string} projectId The ID of the project.
         * @param {string} publicationRequestId The ID of the publication request.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getPublicationRequest(projectId: string, publicationRequestId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectPublicationRequestDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getPublicationRequest(projectId, publicationRequestId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectPublicationRequestApi.getPublicationRequest']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectPublicationRequestApi - factory interface
 * @export
 */
export const ProjectPublicationRequestApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectPublicationRequestApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdPublicationsRequestsOptions(requestParameters: ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdPublicationsRequestsOptions(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Creates a new publication request.
         * @param {ProjectPublicationRequestApiCreatePublicationRequestRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createPublicationRequest(requestParameters: ProjectPublicationRequestApiCreatePublicationRequestRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectPublicationRequestDtoResponse> {
            return localVarFp.createPublicationRequest(requestParameters.projectId, requestParameters.publicationRequestForCreationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a publication request.
         * @param {ProjectPublicationRequestApiGetPublicationRequestRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPublicationRequest(requestParameters: ProjectPublicationRequestApiGetPublicationRequestRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectPublicationRequestDtoResponse> {
            return localVarFp.getPublicationRequest(requestParameters.projectId, requestParameters.publicationRequestId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdPublicationsRequestsOptions operation in ProjectPublicationRequestApi.
 * @export
 * @interface ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptionsRequest
 */
export interface ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptions
     */
    readonly projectId: string
}

/**
 * Request parameters for createPublicationRequest operation in ProjectPublicationRequestApi.
 * @export
 * @interface ProjectPublicationRequestApiCreatePublicationRequestRequest
 */
export interface ProjectPublicationRequestApiCreatePublicationRequestRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectPublicationRequestApiCreatePublicationRequest
     */
    readonly projectId: string

    /**
     * The publication request data for creation.
     * @type {PublicationRequestForCreationDto}
     * @memberof ProjectPublicationRequestApiCreatePublicationRequest
     */
    readonly publicationRequestForCreationDto?: PublicationRequestForCreationDto
}

/**
 * Request parameters for getPublicationRequest operation in ProjectPublicationRequestApi.
 * @export
 * @interface ProjectPublicationRequestApiGetPublicationRequestRequest
 */
export interface ProjectPublicationRequestApiGetPublicationRequestRequest {
    /**
     * The ID of the project.
     * @type {string}
     * @memberof ProjectPublicationRequestApiGetPublicationRequest
     */
    readonly projectId: string

    /**
     * The ID of the publication request.
     * @type {string}
     * @memberof ProjectPublicationRequestApiGetPublicationRequest
     */
    readonly publicationRequestId: string
}

/**
 * ProjectPublicationRequestApi - object-oriented interface
 * @export
 * @class ProjectPublicationRequestApi
 * @extends {BaseAPI}
 */
export class ProjectPublicationRequestApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectPublicationRequestApi
     */
    public apiV2ProjectsProjectIdPublicationsRequestsOptions(requestParameters: ProjectPublicationRequestApiApiV2ProjectsProjectIdPublicationsRequestsOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectPublicationRequestApiFp(this.configuration).apiV2ProjectsProjectIdPublicationsRequestsOptions(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Creates a new publication request.
     * @param {ProjectPublicationRequestApiCreatePublicationRequestRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectPublicationRequestApi
     */
    public createPublicationRequest(requestParameters: ProjectPublicationRequestApiCreatePublicationRequestRequest, options?: RawAxiosRequestConfig) {
        return ProjectPublicationRequestApiFp(this.configuration).createPublicationRequest(requestParameters.projectId, requestParameters.publicationRequestForCreationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a publication request.
     * @param {ProjectPublicationRequestApiGetPublicationRequestRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectPublicationRequestApi
     */
    public getPublicationRequest(requestParameters: ProjectPublicationRequestApiGetPublicationRequestRequest, options?: RawAxiosRequestConfig) {
        return ProjectPublicationRequestApiFp(this.configuration).getPublicationRequest(requestParameters.projectId, requestParameters.publicationRequestId, options).then((request) => request(this.axios, this.basePath));
    }
}

